package com.ruoyi.project.patrol.fire.controller;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.ExcelUtils;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.patrol.fire.domain.TFireSprinkler;
import com.ruoyi.project.patrol.fire.service.ITFireSprinklerService;
import com.ruoyi.project.patrol.patrol.domain.TPatrolIssues;
import com.ruoyi.project.patrol.patrol.domain.TPatrolPlan;
import com.ruoyi.project.patrol.patrol.service.ITPatrolIssuesService;
import com.ruoyi.project.patrol.patrol.service.ITPatrolPlanService;
import com.ruoyi.project.system.domain.SysUser;
import com.ruoyi.project.system.service.ISysUserService;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * 自动喷淋灭火系统检查记录Controller
 *
 * @author admin
 * @date 2023-11-01
 */
@RestController
@RequestMapping("/fire/sprinkler")
public class TFireSprinklerController extends BaseController {
    @Autowired
    private ITFireSprinklerService tFireSprinklerService;

    @Autowired
    private ITPatrolPlanService tPatrolPlanService;

    @Autowired
    private ITPatrolIssuesService tPatrolIssuesService;

    @Autowired
    private ISysUserService sysUserService;

    /**
     * 查询自动喷淋灭火系统检查记录列表
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:list')")
    @GetMapping("/list")
    public TableDataInfo list(TFireSprinkler tFireSprinkler) {
        startPage();
        if (StringUtils.isEmpty(tFireSprinkler.getIssuesFlag()))
            tFireSprinkler.setIssuesFlag("0");
        List<TFireSprinkler> list = tFireSprinklerService.selectTFireSprinklerList(tFireSprinkler);
        return getDataTable(list);
    }

    /**
     * 导出自动喷淋灭火系统检查记录列表
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:export')")
    @Log(title = "自动喷淋灭火系统检查记录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public AjaxResult export(TFireSprinkler tFireSprinkler) {
        try {
            tFireSprinkler.setIssuesFlag("0");
            List<TFireSprinkler> list = tFireSprinklerService.selectTFireSprinklerList(tFireSprinkler);
            XSSFWorkbook workbook = new XSSFWorkbook();
            // 创建工作簿
            XSSFSheet sheet = workbook.createSheet();
            // 设置列宽
            sheet.setColumnWidth(0, 1200);
            sheet.setColumnWidth(1, 3500);
            sheet.setColumnWidth(2, 3500);
            sheet.setColumnWidth(3, 4500);
            sheet.setColumnWidth(4, 4500);
            sheet.setColumnWidth(5, 4500);
            sheet.setColumnWidth(6, 4500);
            sheet.setColumnWidth(7, 4500);
            sheet.setColumnWidth(8, 4500);
            sheet.setColumnWidth(9, 4500);
            sheet.setColumnWidth(10, 4500);
            //第一行
            XSSFRow row1 = sheet.createRow(0);
            row1.createCell(0).setCellValue("CBP-6.3.0-SCFSH-020.06  Rev:04  2021/10/01");
            ExcelUtils.createVoidCell(1, 10, row1);
            sheet.addMergedRegion(new CellRangeAddress(0, 0, 0, 10));//合并
            //第二行
            XSSFRow row2 = sheet.createRow(1);
            row2.createCell(0).setCellValue("自动喷淋灭火系统检查记录");
            ExcelUtils.createVoidCell(1, 10, row2);
            sheet.addMergedRegion(new CellRangeAddress(1, 1, 0, 10));
            //第三行
            XSSFRow row3 = sheet.createRow(2);
            row3.createCell(0).setCellValue("年度：" + tFireSprinkler.getYear());
            sheet.addMergedRegion(new CellRangeAddress(2, 2, 0, 2));
            ExcelUtils.createVoidCell(1, 10, row3);
            row3.createCell(3).setCellValue("检查频率：1次/3月");
            sheet.addMergedRegion(new CellRangeAddress(2, 2, 3, 10));
            //第四行
            XSSFRow row4 = sheet.createRow(3);
            row4.createCell(0).setCellValue("序号");
            row4.createCell(1).setCellValue("位号");
            row4.createCell(2).setCellValue("位置");
            row4.createCell(3).setCellValue("检查内容");
            ExcelUtils.createVoidCell(4, 10, row4);
            sheet.addMergedRegion(new CellRangeAddress(3, 3, 3, 10));
            //第五行
            XSSFRow row5 = sheet.createRow(4);
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 0, 0));
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 1, 1));
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 2, 2));
            ExcelUtils.createVoidCell(0, 2, row5);
            row5.createCell(3).setCellValue("进、出水阀门锁开状态");
            row5.createCell(4).setCellValue("电伴热保温");
            row5.createCell(5).setCellValue("开式喷头");
            row5.createCell(6).setCellValue("消防水压力表，及水力警铃");
            row5.createCell(7).setCellValue("水力紧急启动阀及气动紧急启动阀");
            row5.createCell(8).setCellValue("导淋阀");
            row5.createCell(9).setCellValue("水力手动、气动手动和远程测试");
            row5.createCell(10).setCellValue("检查人");
            Long planId = null;
            //遍历数组赋值
            for (int i = 0; i < list.size(); i++) {
                TFireSprinkler sprinkler = list.get(i);
                planId = sprinkler.getPlanId();
                XSSFRow row = sheet.createRow(5 + i);
                row.createCell(0).setCellValue(i + 1);
                row.createCell(1).setCellValue(sprinkler.getDevNo());
                row.createCell(2).setCellValue(sprinkler.getPosition());
                row.createCell(3).setCellValue("1".equals(sprinkler.getLockedCondition()) ? "√" : sprinkler.getLockedCondition());
                row.createCell(4).setCellValue("1".equals(sprinkler.getKeepWarm()) ? "√" : sprinkler.getKeepWarm());
                row.createCell(5).setCellValue("1".equals(sprinkler.getOpenSprinkler()) ? "√" : sprinkler.getOpenSprinkler());
                row.createCell(6).setCellValue("1".equals(sprinkler.getPressureGage()) ? "√" : sprinkler.getPressureGage());
                row.createCell(7).setCellValue("1".equals(sprinkler.getPrimingValve()) ? "√" : sprinkler.getPrimingValve());
                row.createCell(8).setCellValue("1".equals(sprinkler.getShowerValve()) ? "√" : sprinkler.getShowerValve());
                row.createCell(9).setCellValue("1".equals(sprinkler.getValveTesting()) ? "√" : sprinkler.getValveTesting());
                XSSFCell cell10 = row.createCell(10);
                if (StringUtils.isNotEmpty(sprinkler.getUpdaterCode())) {
                    SysUser sysUser = sysUserService.selectUserById(Long.valueOf(sprinkler.getUpdaterCode()));
                    cell10.setCellValue(sysUser == null ? "" : sysUser.getNickName());
                }
            }
            String confirmed = "";
            Date confirmedDate = null;
            TPatrolPlan tPatrolPlan = tPatrolPlanService.selectTPatrolPlanById(planId);
            if (Objects.nonNull(tPatrolPlan) && Objects.nonNull(tPatrolPlan.getConfirmed())) {
                SysUser sysUser = sysUserService.selectUserById(Long.valueOf(tPatrolPlan.getConfirmed()));            if (sysUser!=null) {
                confirmed = sysUser.getSignUrl();
                confirmedDate = tPatrolPlan.getConfirmDate();
            }
            }
            // 循环后下一行
            int nextRowNum = 5 + list.size();
            XSSFRow row28 = sheet.createRow(nextRowNum);
            row28.setHeightInPoints(30);
            XSSFCell row28Cell1 = row28.createCell(0);
            row28Cell1.setCellValue("签名");
            ExcelUtils.createVoidCell(1, 2, row28);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 2));
            if (StringUtils.isNotEmpty(confirmed))
                ExcelUtils.insertPicture(workbook, sheet, confirmed, nextRowNum, 5, 1, 1);
            ExcelUtils.createVoidCell(3, 10, row28);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 3, 10));
            // 下一行
            nextRowNum++;
            XSSFRow row29 = sheet.createRow(nextRowNum);
            row29.setHeightInPoints(30);
            XSSFCell row29Cell1 = row29.createCell(0);
            row29Cell1.setCellValue("日期");
            ExcelUtils.createVoidCell(1, 2, row29);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 2));
            row29.createCell(3).setCellValue(confirmedDate != null ? new SimpleDateFormat("yyyy-MM-dd").format(confirmedDate) : "");
            ExcelUtils.createVoidCell(4, 10, row29);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 3, 10));
            // 设置单元格样式
            // 文字居中，自动换行，四周边框
            CellStyle style = workbook.createCellStyle();
            style.setAlignment(HorizontalAlignment.CENTER);
            style.setVerticalAlignment(VerticalAlignment.CENTER);
            style.setWrapText(true);
            style.setBorderTop(BorderStyle.THIN);
            style.setBorderBottom(BorderStyle.THIN);
            style.setBorderLeft(BorderStyle.THIN);
            style.setBorderRight(BorderStyle.THIN);

            // 设置垂直居中，四周边框
            CellStyle style2 = workbook.createCellStyle();
            style2.setVerticalAlignment(VerticalAlignment.CENTER);
            style2.setBorderTop(BorderStyle.THIN);
            style2.setBorderBottom(BorderStyle.THIN);
            style2.setBorderLeft(BorderStyle.THIN);
            style2.setBorderRight(BorderStyle.THIN);
            for (Row row : sheet) {
                row.setHeightInPoints(30);
                if (row.getRowNum() == 0) {
                    continue;
                }
                if (row.getRowNum() == 2) {
                    for (Cell cell : row) {
                        if (cell.getColumnIndex() == 0 || cell.getColumnIndex() == 1 || cell.getColumnIndex() == 2)
                            cell.setCellStyle(style2);
                        else
                            cell.setCellStyle(style);
                    }
                } else {
                    for (Cell cell : row) {
                        cell.setCellStyle(style);
                    }
                }
            }
            nextRowNum++;
            XSSFRow row30 = sheet.createRow(nextRowNum);
            row30.createCell(0).setCellValue("说明：");
            ExcelUtils.createVoidCell(1, 10, row30);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 10));

            nextRowNum++;
            XSSFRow row31 = sheet.createRow(nextRowNum);
            row31.createCell(0).setCellValue("1.检查正常打“√”。");
            ExcelUtils.createVoidCell(1, 10, row31);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 10));

            nextRowNum++;
            XSSFRow row32 = sheet.createRow(nextRowNum);
            row32.createCell(0).setCellValue("2.检查有不正常情况打“X”，并记录存在问题，处理结果及完成时间。");
            ExcelUtils.createVoidCell(1, 10, row32);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 10));

            nextRowNum++;
            XSSFRow row33 = sheet.createRow(nextRowNum);
            row33.createCell(0).setCellValue("3. 检查频率为每3个月检查维护一次。");
            ExcelUtils.createVoidCell(1, 10, row33);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 10));

            //返回
            String fileName = ExcelUtil.encodingFilename("main");
            OutputStream os = Files.newOutputStream(Paths.get(ExcelUtil.getAbsoluteFile(fileName)));
            workbook.write(os);
            workbook.close();
            return AjaxResult.success(fileName);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 获取自动喷淋灭火系统检查记录详细信息
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return AjaxResult.success(tFireSprinklerService.selectTFireSprinklerById(id));
    }

    /**
     * 获取自动喷淋灭火系统检查记录详细信息
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:query')")
    @GetMapping(value = "/info")
    public AjaxResult getInfo(TFireSprinkler tFireSprinkler) {
        if (StringUtils.isEmpty(tFireSprinkler.getDevNo()) || StringUtils.isNull(tFireSprinkler.getPlanId())) {
            return AjaxResult.error("位号或计划id不能为空！");
        }
        TFireSprinkler item = new TFireSprinkler();
        item.setPlanId(tFireSprinkler.getPlanId());
        item.setPrecision(tFireSprinkler.getDevNo());
        item.setIssuesFlag("0");
        List<TFireSprinkler> items = tFireSprinklerService.selectTFireSprinklerList(item);
        if (CollectionUtils.isNotEmpty(items))
            return AjaxResult.success(items.get(0));
        return AjaxResult.error("此设备不在当前巡检计划中!");
    }

    /**
     * 新增自动喷淋灭火系统检查记录
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:add')")
    @Log(title = "自动喷淋灭火系统检查记录", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TFireSprinkler tFireSprinkler) {
        return toAjax(tFireSprinklerService.insertTFireSprinkler(tFireSprinkler));
    }

    /**
     * 修改自动喷淋灭火系统检查记录
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:edit')")
    @Log(title = "自动喷淋灭火系统检查记录", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TFireSprinkler tFireSprinkler) {
        tFireSprinkler.setUpdatedate(new Date());
        tFireSprinkler.setUpdaterCode(getUserId().toString());
        tFireSprinkler.setCheckStatus("1");
        tFireSprinkler.setCheckDate(new Date());
        TFireSprinkler item = tFireSprinklerService.selectTFireSprinklerById(tFireSprinkler.getId());
        TPatrolPlan tPatrolPlan = tPatrolPlanService.selectTPatrolPlanById(tFireSprinkler.getPlanId());
        if (tPatrolPlan.getStatus()==1){
            return AjaxResult.error("当前选择的计划已确认！");
        }
        if (!"1".equals(item.getCheckStatus())) {
            tPatrolPlan.setUncheckedNum(tPatrolPlan.getUncheckedNum() - 1);
            tPatrolPlan.setCheckedNum(tPatrolPlan.getCheckedNum() + 1);
            tPatrolPlanService.updateTPatrolPlan(tPatrolPlan);
        }
        if ((StringUtils.isNotEmpty(tFireSprinkler.getOpenSprinkler()) && !"1".equals(tFireSprinkler.getOpenSprinkler())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getKeepWarm()) && !"1".equals(tFireSprinkler.getKeepWarm())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getLockedCondition()) && !"1".equals(tFireSprinkler.getLockedCondition())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getPressureGage()) && !"1".equals(tFireSprinkler.getPressureGage())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getPrimingValve()) && !"1".equals(tFireSprinkler.getPrimingValve())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getShowerValve()) && !"1".equals(tFireSprinkler.getShowerValve())) ||
                (StringUtils.isNotEmpty(tFireSprinkler.getValveTesting()) && !"1".equals(tFireSprinkler.getValveTesting()))) {
            tFireSprinkler.setIssuesStatus("1");
            tFireSprinkler.setCheckStatus("0");
            tFireSprinklerService.updateTFireSprinkler(tFireSprinkler);
            tFireSprinkler.setIssuesFlag("1");
            tFireSprinkler.setCheckStatus("1");
            tFireSprinkler.setCreatedate(new Date());
            tFireSprinkler.setCreaterCode(getUserId().toString());
            tFireSprinkler.setDevNo(item.getDevNo());
            tFireSprinkler.setPosition(item.getPosition());
            tFireSprinklerService.insertTFireSprinkler(tFireSprinkler);
            TPatrolIssues tPatrolIssues = new TPatrolIssues();
            tPatrolIssues.setPatrolType("6");
            tPatrolIssues.setDevDescribe(tFireSprinkler.getDevNo() + " " + tFireSprinkler.getPosition());
            tPatrolIssues.setLinkId(tFireSprinkler.getId());
            tPatrolIssues.setStatus(0L);
            tPatrolIssuesService.insertTPatrolIssues(tPatrolIssues);
        } else {
            if ("1".equals(item.getIssuesStatus())) {
                TPatrolIssues tPatrolIssues = new TPatrolIssues();
                tPatrolIssues.setPatrolType("6");
                tPatrolIssues.setDevDescribe(item.getDevNo() + " " + item.getPosition());
                tPatrolIssues.setCreatedate(new Date());
                for (TPatrolIssues patrolIssues : tPatrolIssuesService.selectTPatrolIssuesList(tPatrolIssues)) {
                    patrolIssues.setStatus(1L);
                    tPatrolIssuesService.updateTPatrolIssues(patrolIssues);
                }
            }
            tFireSprinkler.setIssuesStatus("0");
            tFireSprinklerService.updateTFireSprinkler(tFireSprinkler);
        }
        return AjaxResult.success();
    }

    /**
     * 删除自动喷淋灭火系统检查记录
     */
    @PreAuthorize("@ss.hasPermi('fire:sprinkler:remove')")
    @Log(title = "自动喷淋灭火系统检查记录", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tFireSprinklerService.deleteTFireSprinklerByIds(ids));
    }
}
